/*
 *  linux/arch/$(ARCH)/platform/$(PLATFORM)/config.c
 *
 *  Copyright (C) 2001 Empower Technologies Inc.
 * 
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file COPYING in the main directory of this archive
 * for more details.
 */

#include <stdarg.h>
#include <linux/config.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/tty.h>
#include <linux/console.h>

#include <asm/setup.h>
#include <asm/system.h>
#include <asm/pgtable.h>
#include <asm/irq.h>
#include <asm/machdep.h>

extern void register_console(void (*proc)(const char *));

void BSP_sched_init(void (*timer_routine)(int, void *, struct pt_regs *))
{
  /* start timer */
	(*((volatile unsigned short*)0xFFFFF604)) = 109;	/*0xd7e4*/ 	// Timer Compare Register
	(*((volatile unsigned short*)0xFFFFF600)) = 0x39;  // Timer Control register
	(*((volatile unsigned short*)0xFFFFF602)) = 0x2;  /* system clock / (value+1) */

	request_irq(IRQ_MACHSPEC | 1, timer_routine, IRQ_FLG_LOCK, "timer", NULL);
}

void BSP_tick(void)
{
  /* Reset Timer1 */
  (*((volatile unsigned short*)0xFFFFF60A)) &= 0;
}

unsigned long BSP_gettimeoffset (void)
{
  return 0;
}

void BSP_gettod (int *yearp, int *monp, int *dayp,
		   int *hourp, int *minp, int *secp)
{
}

int BSP_hwclk(int op, struct hwclk_time *t)
{
  if (!op) {
    /* read */
  } else {
    /* write */
  }
  return 0;
}

int BSP_set_clock_mmss (unsigned long nowtime)
{
#if 0
  short real_seconds = nowtime % 60, real_minutes = (nowtime / 60) % 60;

  tod->second1 = real_seconds / 10;
  tod->second2 = real_seconds % 10;
  tod->minute1 = real_minutes / 10;
  tod->minute2 = real_minutes % 10;
#endif
  return 0;
}

void BSP_reset (void)
{
  cli();
  asm volatile ("
    moveal #0x10c00000, %a0;
    moveb #0, 0xFFFFF300;
    moveal 0(%a0), %sp;
    moveal 4(%a0), %a0;
    jmp (%a0);
    ");
}

void config_BSP(void)
{
#ifdef CONFIG_68328_SERIAL
  extern void console_print_68328(const char * b);
  register_console(console_print_68328);
#endif  

  printk("\n68EZ328 DragonBallEZ support (C) 2001 Empower Technologies, Inc\n");
 
  mach_sched_init      = BSP_sched_init;
  mach_tick            = BSP_tick;
  mach_gettimeoffset   = BSP_gettimeoffset;
  mach_gettod          = BSP_gettod;
  mach_hwclk           = NULL;
  mach_set_clock_mmss  = NULL;
  mach_mksound         = NULL;
  mach_reset           = BSP_reset;
  mach_debug_init      = NULL;

  config_M68EZ328_irq();
}
