#include <linux/config.h>
#include <linux/module.h>
#include <linux/delay.h>
#include <linux/kernel.h>
#include <linux/busmouse.h>
#include <linux/signal.h>
#include <linux/errno.h>
#include <linux/mm.h>
#include <linux/miscdevice.h>
#include <linux/ptrace.h>
#include <linux/ioport.h>
#include <linux/interrupt.h>
#include <linux/timer.h>


#include "mc68328_regs.h"
#include "irda.h"


#define DIFF_LIMIT 0x25
#define DIFF_UNSTABLE_LIMIT	0x07

int EDGE_X_MIN_LIMIT=0x0;//0xdc0;//d40
int EDGE_X_MAX_LIMIT=0xfff;//0x130;//110
int EDGE_Y_MIN_LIMIT=0x0;//0xe10;//e30
int EDGE_Y_MAX_LIMIT=0xfff;//0x500;//4e0

int DIGI_X_MIN_LIMIT=11;//0
int DIGI_X_MAX_LIMIT=149;
int DIGI_Y_MIN_LIMIT=11;//0
int DIGI_Y_MAX_LIMIT=149;


static U8 pPB_DAT,pPD_DAT,pPE_DAT,pPF_DAT,pPG_DAT;
static U8 pPB_DIR,pPD_DIR,pPE_DIR,pPF_DIR,pPG_DIR;
static U8 pPB_SEL,pPD_SEL,pPE_SEL,pPF_SEL,pPG_SEL;
// store the status of registers so that we can restore it anytime
static U16 pUSTCNT;

/*** used to enable digi interrupt ***/
static void digi_timedout(unsigned long ignore);
static struct timer_list digi_timer={NULL,NULL,0,0,digi_timedout};
// enable digizer interrut 10 times in one secong
static void digi_timedout(unsigned long ignore)
{
	del_timer(&digi_timer);
	//printk("enable digi interrupt\n");
	enable_pen_irq();
}
void digi_timer_callback(int ticks)
{
	cli();
	del_timer(&digi_timer);
	digi_timer.expires = jiffies+ticks;
	add_timer(&digi_timer);
	sti();
}



U32 GetRTCTime(void)
{
	U32 retValue;
	U32 c_time,c_day;
	
	c_time = RTCTIME;
	c_day = RTCDAY;
	
	retValue = (c_time & 0x003f) + ((c_time & 0x3f0000) >> 16) * 60 
								+ ((c_time & 0x3f000000) >> 24) * 3600;
	retValue += (c_day&0x1ff)*86400;
	//printk("rtc:%x,day:%x,retValue:%x\n",c_time,c_day,retValue);
	return retValue;
}


/*----------------------------------------------------*/
