U8 kb_interrupt(int irq, void *ptr, struct pt_regs *reg)
{
	U8 kc, temp, temp_noise;
	U32 m, now_time, last_time;
	
	asm("or.l #0x700, 0xfffff304"); //disable Int0:2
	kc = 0;
	
	if(powerFlag == 0) //if PDA is turn off, just turn on it
	{
		asm("move.b #0xff,   0xfffff402"); //pull up PA
		asm("move.w #0x9627, 0xfffffc02"); //recover Dram to CSR fresh mode
		                                   //old = 0x9627, new = 0x8407
	
		asm("or.b #0x08, 0xfffff409"); //disable 7843 #CS
		asm("or.b #0x80, 0xfffffa27"); //enable LCD module in CPU
		for(m = 0; m < 2000; m++);
	
		asm("or.b #0x01, 0xfffff429"); //PF0=1: open 8330's #CE
		asm("move.w #0xe207, 0xfffff802"); //set control byte of SPIM
		asm("move.w #0xac, 0xfffff800");

		asm("or.b  #0x40, 0xfffff429");
		asm("and.b #0xbf, 0xfffff429");
		asm("or.w #0x0100, 0xfffff802"); //send controll byte
		asm("move.l #0xfffff802, %a0"); //test send finish flag
		asm("my_loop200: move.w (%a0), %d0");
		asm("and.w #256, %d0");
		asm("tst.w %d0");
		asm("jbne my_loop200");

		asm("or.b  #0x40,  0xfffff429"); //send out another strobe to 8330
		asm("and.b #0xbf,  0xfffff429");
		asm("and.w #0xfdff,0xfffff802"); //disable SPIM

		powerFlag = 1;
		asm("or.b   #0x01, 0xfffff601"); //Timer enable
		do{
			temp = PORT_D_DAT & 0x01;
		}while(temp); //wait for button released
		for(m = 0; m < 10000; m++); //delay to remove noise 
		asm("or.b #0x01, 0xfffff41f"); //restore Int0 to be edge trigged
		
		now_time = (RTCTIME & 0x003f) + ((RTCTIME & 0x3f0000) >> 16) * 60 + ((RTCTIME & 0x3f000000) >> 24) * 3600;
		xtime.tv_sec += (now_time - last_time);
		return 0;
	}
	
	
	for(m = 0; m < 2000; m++); //delay to remove noise
	asm("or.b #0xb0, 0xfffff419"); //PORT_D_DAT |= 0xb0
	for(m = 0; m < 10; m++);
	asm("and.b #0x0f, 0xfffff419"); //PORT_D_DAT &= 0x0f
	for(m = 0; m < 10; m++);
	temp_noise = PORT_D_DAT & 0x0f;
	
	if(temp_noise) //if this click is not noise
	{
		asm("or.b #0xb0, 0xfffff419"); //PD_D_DAT |= 0xb0
		for(m = 0; m < 10; m++);
		asm("and.b #0x7f, 0xfffff419"); //PD_D_DAT &= 0x7f
		for(m = 0; m < 10; m++);
		temp = PORT_D_DAT & 0x0f;

		if(temp) //if the button is in column 1
		{
			switch(temp)
			{
				case 1:  //if this is 'Power' button
			
					pIMR = PORT_IMR; //save the interrupt mask
					LightOff();

					asm("move.w #0x2700, %sr"); //mask all interrupt
					asm("move.l #0xfffeff, 0xfffff304"); //open Int0 mask
					last_time = (RTCTIME & 0x003f) + ((RTCTIME & 0x3f0000) >> 16) * 60 + ((RTCTIME & 0x3f000000) >> 24) * 3600;
					asm("and.b  #0x0e, 0xfffff41f"); //set Int0 to be level trigged
					powerFlag = 0;

					asm("or.b   #0x30, 0xfffff431"); //close PG4,5 --- power of microphone
					asm("and.b  #0xf5, 0xfffff431"); //turn off RS232, turn off EL
					asm("or.b   #0x08, 0xfffff409"); //disable 7843's #CS
					asm("and.b  #0xfe, 0xfffff429"); //disable 8330's On/#Off
  	      		asm("and.b  #0xfd, 0xfffff802"); //close SPIM
					asm("and.b  #0xef, 0xfffff501"); //close PWM
					asm("and.b  #0xfe, 0xfffff601"); //disable timer

					do{
						temp = PORT_D_DAT & 0x01;
					}while(temp); //wait for button released
					for(m = 0; m < 10000; m++); //delay to remove noise
					PORT_D_DAT |= 0x40; //pull up PD6 to save power 
					asm("move.b #0x00, 0xfffff402"); //not pull up PA to save power
	
					asm("sync1: btst.b #0x07, 0xfffff202");
					asm("bne.s sync1");
					asm("sync2: btst.b #0x07, 0xfffff202");
					asm("beq.s sync2");
					asm("bset.b #0x03,   0xfffff201"); //set DISPLL bit
					asm("move.w #0xd237, 0xfffffc02"); //set Dram to self-fresh mode
				  	                                 //= 0xc017 or 0xd237
					asm("stop   #0x2000");
						
					PORT_D_DAT &= 0x4f; //pull down PD7,5,4 to receive new int
					PORT_IMR = pIMR & 0xfff8ff; //restore int mask(open Int0:2)
					asm("rte");
						
				case 2: kc = KEY_LEFT; break;
				case 4: kc = KEY_RETURN; break;
			} //end of 'switch'
		}
		else //if button is not in column 1
		{
			asm("or.b #0xb0, 0xfffff419"); //PORT_D_DAT |= 0xb0
			for(m = 0; m < 10; m++);
			asm("and.b #0xef, 0xfffff419"); //PORT_D_DAT &= 0xef
			for(m = 0; m < 10; m++);
			temp = PORT_D_DAT & 0x0f;

			if(temp) //if button is in column 2
			{
				switch(temp)
				{
					case 1: kc = KEY_ADDRESS; break;
					case 2: kc = KEY_LIGHT; break;
					case 4: kc = KEY_RIGHT; break;
				}
			}
			else //if button is not in column 1 or 2
			{
				asm("or.b #0xb0, 0xfffff419"); //PD_D_DAT |= 0xb0
				for(m = 0; m < 10; m++);
				asm("and.b #0xdf, 0xfffff419"); //PD_D_DAT &= 0xdf
				for(m = 0; m < 10; m++);
				temp = PORT_D_DAT & 0x0f;

				if(temp) //if button is in column 3
				{
					switch(temp)
					{
						case 1: kc = KEY_UP; break;
						case 2: kc = KEY_DOWN; break;
					}
				}
			} //end of 'if(button is in column 2)....else....'
		} //end of 'if(button is in column 1)....else....'
	}//end of 'if(this click is not noise)'
		
	PORT_D_DAT &= 0x4f; //pull down PD7,5,4 to receive new int
	for(m = 0; m < 10; m++);
	PORT_IMR &= 0xfff8ff; //enable Int0:2
	return 0;
}
