
all::

ifndef TOP
TOP = .
endif

ifdef EMBED

ARCH = $(TOP)/arch/embed
BUILD = $(TOP)/build/embed
O = embed.o
CC = m68k-pic-coff-gcc
OBJCOPY = m68k-pic-coff-objcopy
LD = m68k-pic-coff-ld --embedded-relocs
RANLIB = m68k-pic-coff-ranlib

# Please correct location of m68k-pic-coff libgcc
LIBGCC = `$(CC) -v 2>&1 | grep specs | sed -e "s/Reading specs from //" | sed -e s/specs/libgcc.a/`

STARTUP = $(ARCH)/crt0.o


CFLAGS = -O2 -m68000 -g -fno-builtin -msoft-float -D__linux__ -DEMBED -I$(TOP)/../libc/include -I$(TOP)/../libm 
COFF2FLT = $(TOP)/../coff2flt-0.3/coff2flt
LINK = $(LD) -T $(ARCH)/user.ld $(STARTUP) $^ $(TOP)/../libc/libc.a $(LIBGCC) -o $@.coff && $(COFF2FLT) -o $@ $@.coff $(LDFLAGS)
LINKM = $(LD) -T $(ARCH)/user.ld $(STARTUP) $^ $(TOP)/../libc/libc.a $(TOP)/../libm/libmf.a $(LIBGCC) -o $@.coff && $(COFF2FLT) -o $@ $@.coff $(LDFLAGS)

.PHONY: $(STARTUP)

$(STARTUP): $(ARCH)/crt0.S
	$(CC) $(CFLAGS) -c $< -o $@

clean::
	rm -f *.coff

else

ARCH = $(TOP)/arch/pc
BUILD = $(TOP)/build/pc
O = pc.o
CC = gcc
CFLAGS = -g
LINK = $(CC) -g $^ -o $@ -lefence $(LDFLAGS)
LINKM = $(CC) -g $^ -lm -o $@ -lefence $(LDFLAGS)
RANLIB = ranlib

endif

ifneq "$(TOP)" "."

doc lynxdoc netscapedoc:
	$(MAKE) -C $(TOP) $@

ifndef uploader

install:
	$(MAKE) -C $(TOP) $@

upload:
	$(MAKE) -C $(TOP) $@

endif

endif

adderrors:
	perl $(TOP)/liberror/adderrors.pl $(TOP)/liberror/IPSErrorCodes.h *.[ch]

realclean:: clean
	rm -f *.o
	rm -f $(foreach dir, $(wildcard $(TOP)/build/*), $(foreach file, $(notdir $(CLEAN)), $(dir)/$(file)))

clean::
	rm -f *.$(O) *~ core

.SUFFIXES : .$(O)

%.$(O) : %.c ; $(CC) $(CFLAGS) -c $< -o $@

LIBNET = $(BUILD)/libnet.a $(TOP)/libnet/libnet-libstamp.$(O)
INCNET = -I$(TOP)/libnet

LIBSERIAL = $(BUILD)/libserial.a $(TOP)/libserial/libserial-libstamp.$(O)
INCSERIAL = -I$(TOP)/libserial

LIBRESOLV = $(BUILD)/libresolv.a $(TOP)/libresolv/libresolv-libstamp.$(O)
INCRESOLV = -I$(TOP)/libresolv

LIBRPC = $(BUILD)/librpc.a $(TOP)/librpc/librpc-libstamp.$(O)
INCRPC = -I$(TOP)/librpc

INCDEBUG = -I$(TOP)/libdebug

