/* mem.h: Safe string manipulation
 *
 * Copyright (C) 1998  Kenneth Albanowski <kjahds@kjahds.com>,
 *                     The Silver Hammer Group, Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */

#ifndef _MEM_H_
#define _MEM_H_

#define Strcpy(dest, destend, src) (strncpy(dest, src, destend-dest), dest+strlen(dest))
#define Strcat(dest, destend, src) Strcpy(dest+strlen(dest), destend, src)
#define Strprintf(dest, destend, fmt, args...) (sprintf(dest, fmt, ## args), dest+strlen(dest))

#define Strcpyn(dest, destend, src, max) \
		(strncpy(dest, src, ((dest+max) > destend) ? destend-dest : max), dest+strlen(dest))

#define Strcatn(dest, destend, src, max) \
		Strncpy(dest+strlen(dest), destend, max)


#endif /* _MEM_H_ */