
%.libstamp: Makefile $(TOP)/libversion.mk
	@echo "Touching $*.libstamp"
	@if [ ! -f $@ ]; then \
		echo 1 > $*.libstamp; \
	else \
		expr 0`cat $*.libstamp` + 1 > $*.libstamp; \
	fi

%-libstamp.c: %.libstamp
	@if [ -f .name ]; then \
	  echo \#define LIBRARY_VERSION \"\#`cat $*.libstamp`-`cat .name` `date`\"; \
	  tag="$($*.VERSION).$($*.PATCHLEVEL).$($*.SUBLEVEL)	#`cat $*.libstamp`-`cat .name` `date`"; \
	 else \
	  echo \#define LIBRARY_VERSION \"\#`cat $*.libstamp` `date`\";  \
	  tag="$($*.VERSION).$($*.PATCHLEVEL).$($*.SUBLEVEL)	#`cat $*.libstamp` `date`"; \
	 fi >> .programid; \
	if [ "`head -1 ChangeLog.$*`" != "$$tag" ]; then \
	  echo "$$tag" > .changelog; \
	  echo "" >> .changelog; \
	  cat ChangeLog.$* >> .changelog || true; \
	  mv -f .changelog ChangeLog.$*; \
	  perl $(TOP)/tools/striplogentry.pl ChangeLog.$*; \
	fi
	@echo \#define LIBRARY_COMPILE_TIME \"`date +%T`\" >> .programid
	@echo \#define LIBRARY_COMPILE_BY \"`whoami`\" >> .programid
	@echo \#define LIBRARY_COMPILE_HOST \"`hostname`\" >> .programid
	@if [ -x /bin/dnsdomainname ]; then \
	  echo \#define LIBRARY_COMPILE_DOMAIN \"`dnsdomainname`\"; \
	elif [ -x /bin/domainname ]; then \
	  echo \#define LIBRARY_COMPILE_DOMAIN \"`domainname`\"; \
	else \
	  echo \#define LIBRARY_COMPILE_DOMAIN ; \
	fi >> .programid
	@echo \#define LIBRARY_COMPILER \"`$(CC) -v 2>&1 | tail -1`\" >> .programid
	@echo \#define LIBRARY_BANNER \"$($*.BANNER)\" >> .programid
	@echo \#define LIBRARY_NAME \"$*\" >> .programid
	@echo \#define LIBRARY_RELEASE \"$($*.VERSION).$($*.PATCHLEVEL).$($*.SUBLEVEL)\" >> .programid
	@echo \#define LIBRARY_VERSION_CODE `expr $($*.VERSION) \\* 65536 + $($*.PATCHLEVEL) \\* 256 + $($*.SUBLEVEL)` >> .programid
	@echo 'char library_$*_stamp[] = "$$Library: " LIBRARY_NAME " version " LIBRARY_RELEASE ", build " LIBRARY_VERSION " $$\n" ;' >> .programid
	@mv -f .programid $@

realclean::
	rm -f *-libstamp.c
