
%.stamp: Makefile $(TOP)/version.mk
	@echo "Touching $*.stamp"
	@if [ ! -f $@ ]; then \
		echo 1 > $*.stamp; \
	else \
		expr 0`cat $*.stamp` + 1 > $*.stamp; \
	fi

%.stamp.c: %.stamp
	@if [ -f .name ]; then \
	  echo \#define PROGRAM_VERSION \"\#`cat $*.stamp`-`cat .name` `date`\"; \
	  tag="$($*.VERSION).$($*.PATCHLEVEL).$($*.SUBLEVEL)	#`cat $*.stamp`-`cat .name` `date`"; \
	 else \
	  echo \#define PROGRAM_VERSION \"\#`cat $*.stamp` `date`\";  \
	  tag="$($*.VERSION).$($*.PATCHLEVEL).$($*.SUBLEVEL)	#`cat $*.stamp` `date`"; \
	 fi >> .programid; \
	if [ "`head -1 ChangeLog.$*`" != "$$tag" ]; then \
	  echo "$$tag" > .changelog; \
	  echo "" >> .changelog; \
	  cat ChangeLog.$* >> .changelog || true; \
	  mv -f .changelog ChangeLog.$*; \
	  perl $(TOP)/tools/striplogentry.pl ChangeLog.$*; \
	fi
	@echo \#define PROGRAM_COMPILE_TIME \"`date +%T`\" >> .programid
	@echo \#define PROGRAM_COMPILE_BY \"`whoami`\" >> .programid
	@echo \#define PROGRAM_COMPILE_HOST \"`hostname`\" >> .programid
	@if [ -x /bin/dnsdomainname ]; then \
	  echo \#define PROGRAM_COMPILE_DOMAIN \"`dnsdomainname`\"; \
	elif [ -x /bin/domainname ]; then \
	  echo \#define PROGRAM_COMPILE_DOMAIN \"`domainname`\"; \
	else \
	  echo \#define PROGRAM_COMPILE_DOMAIN ; \
	fi >> .programid
	@echo \#define PROGRAM_COMPILER \"`$(CC) -v 2>&1 | tail -1`\" >> .programid
	@echo \#define PROGRAM_BANNER \"$($*.BANNER)\" >> .programid
	@echo \#define PROGRAM_NAME \"$*\" >> .programid
	@echo \#define PROGRAM_RELEASE \"$($*.VERSION).$($*.PATCHLEVEL).$($*.SUBLEVEL)\" >> .programid
	@echo \#define PROGRAM_VERSION_CODE `expr $($*.VERSION) \\* 65536 + $($*.PATCHLEVEL) \\* 256 + $($*.SUBLEVEL)` >> .programid
	@echo 'char local_stamp[] = "$$Program: " PROGRAM_NAME " version " PROGRAM_RELEASE ", build " PROGRAM_VERSION " $$\n" ;' >> .programid
	@mv -f .programid $@

$(TOP)/version/stamp.$(O):
	$(MAKE) -C $(TOP)/version $@

realclean::
	rm -f *.stamp.c

STAMP = $(TOP)/version/stamp.$(O)

CFLAGS += -I$(TOP)/version

